package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import org.apache.commons.lang.math.NumberUtils;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.InvalidPathException;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;

public class PathInfoTokenizerImpl implements PathInfoTokenizer {

    public long getEntityId(String pathInfo) {
        String[] splitted = pathInfo.split("/");
        String idStr = splitted[splitted.length - 1];
        return Long.parseLong(idStr);
    }

    public String getDaoPrefix(String pathInfo) {
        if(pathInfo == null || "/".equals(pathInfo)) {
            throw new InvalidPathException(pathInfo);
        }
        return pathInfo.split("/")[1];
    }

    public boolean isListAccess(String pathInfo) {
        String[] splitted = pathInfo.split("/");
        String lastToken = splitted[splitted.length - 1];
        return !(NumberUtils.isNumber(lastToken));
    }

}
