package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.DaoOperation;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityListMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.RestOperationDelegate;

import org.apache.commons.io.IOUtils;

public class RestOperationDelegateImpl implements RestOperationDelegate {
    
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        String pathInfo = request.getPathInfo();
        String daoPrefix = pathInfoTokenizer.getDaoPrefix(pathInfo);
        String xml;
        
        if(pathInfoTokenizer.isListAccess(pathInfo)) {
            String listUri = request.getRequestURL().toString();
            List resourceList = daoOperation.getAll(daoPrefix);
            xml = entityListMarshaller.marshal(resourceList, daoPrefix, listUri);
        } else {
            long entityId = pathInfoTokenizer.getEntityId(pathInfo);
            Object result = daoOperation.getById(daoPrefix, entityId);
            xml = entityMarshaller.marshal(result);
        }
        
        writeXmlTo(response, xml);
    }
    
    private void writeXmlTo(HttpServletResponse response, String xml) throws IOException {
        response.setContentType("text/xml");
        response.setCharacterEncoding("UTF-8");
        PrintWriter writer = response.getWriter();
        IOUtils.copy(new StringReader(xml), writer);
        writer.flush();
    }
    
    private EntityListMarshaller entityListMarshaller;
    public void setEntityListMarshaller(EntityListMarshaller entityListMarshaller) {
        this.entityListMarshaller = entityListMarshaller;
    }
    private EntityMarshaller entityMarshaller;
    public void setEntityMarshaller(EntityMarshaller entityMarshaller) {
        this.entityMarshaller = entityMarshaller;
    }

    private PathInfoTokenizer pathInfoTokenizer;
    public void setPathInfoTokenizer(PathInfoTokenizer pathInfoTokenizer) {
        this.pathInfoTokenizer = pathInfoTokenizer;
    }
    private DaoOperation daoOperation;
    public void setDaoOperation(DaoOperation daoOperation) {
        this.daoOperation = daoOperation;
    }
}
