package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.GetMethodAccessHandler;

import org.apache.commons.io.IOUtils;

public abstract class AbstractGetMethodAccessHandler implements GetMethodAccessHandler {

    protected final HttpServletResponse response;
    protected final HttpServletRequest request;

    public AbstractGetMethodAccessHandler(HttpServletRequest request, HttpServletResponse response) {
        this.request = request;
        this.response = response;
    }

    protected void writeXml(String xml) throws IOException {
        response.setContentType("text/xml");
        response.setCharacterEncoding("UTF-8");
        PrintWriter writer = response.getWriter();
        IOUtils.copy(new StringReader(xml), writer);
        writer.flush();
    }

    public abstract void handle() throws IOException;
}