package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.IOException;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.DaoOperation;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityListMarshaller;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;

public class ListAccessHandler extends AbstractGetMethodAccessHandler {

    private final EntityListMarshaller entityListMarshaller;
    private final PathInfoTokenizer pathInfoTokenizer;
    private final DaoOperation daoOperation;

    public ListAccessHandler(HttpServletRequest request,
            HttpServletResponse response,
            PathInfoTokenizer pathInfoTokenizer,
            DaoOperation daoOperation,
            EntityListMarshaller entityListMarshaller) {
        super(request,response);
        this.pathInfoTokenizer = pathInfoTokenizer;
        this.daoOperation = daoOperation;
        this.entityListMarshaller = entityListMarshaller;
    }

    public void handle() throws IOException {
        String daoPrefix = pathInfoTokenizer.getDaoPrefix(request.getPathInfo());
        String listUri = request.getRequestURL().toString();
        List resourceList = daoOperation.getAll(daoPrefix);
        String xml = entityListMarshaller.marshal(resourceList, daoPrefix, listUri);
        writeXml(xml);
    }
}
