package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.GetMethodAccessHandler;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.PathInfoTokenizer;
import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.RestOperationDelegate;

import org.seasar.framework.container.S2Container;

public class RestOperationDelegateImpl implements RestOperationDelegate {

    public void doGet(HttpServletRequest request,
            HttpServletResponse response) throws IOException {
        GetMethodAccessHandler handler = createHandlerFor(request);
        handler.handle();
    }

    private GetMethodAccessHandler createHandlerFor(HttpServletRequest request) {
        GetMethodAccessHandler handler;
        if (pathInfoTokenizer.isListAccess(request.getPathInfo())) {
            handler = (GetMethodAccessHandler) container.getComponent("listAccessHandler");
        } else {
            handler = (GetMethodAccessHandler) container.getComponent("idAccessHandler");
        }
        return handler;
    }

    private S2Container container;
    public void setContainer(S2Container container) {
        this.container = container.getRoot();
    }

    private PathInfoTokenizer pathInfoTokenizer;
    public void setPathInfoTokenizer(
            PathInfoTokenizer pathInfoTokenizer) {
        this.pathInfoTokenizer = pathInfoTokenizer;
    }
}
